## mupen64plus-core 2.0

=== projects/unix/Makefile ===
#/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
# *   Mupen64plus - Makefile                                                *
# *   Mupen64Plus homepage: http://code.google.com/p/mupen64plus/           *
# *   Copyright (C) 2008-2009 Richard Goedeken                              *
# *   Copyright (C) 2007-2008 DarkJeztr Tillin9                             *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.          *
# * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
# Makefile for Mupen64Plus Core

# detect operating system
UNAME ?= $(shell uname -s)
OS := NONE
ifeq ("$(UNAME)","Linux")
  OS = LINUX
endif
ifeq ("$(UNAME)","linux")
  OS = LINUX
endif
ifneq ("$(filter GNU hurd,$(UNAME))","")
  OS = LINUX
endif
ifeq ("$(UNAME)","Darwin")
  OS = OSX
endif
ifeq ("$(UNAME)","FreeBSD")
  OS = FREEBSD
endif
ifeq ("$(UNAME)","OpenBSD")
  OS = FREEBSD
  CFLAGS += -DIOAPI_NO_64
  $(warning OS type "$(UNAME)" not officially supported.')
endif
ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
  OS = LINUX
endif
ifeq ("$(patsubst MINGW%,MINGW,$(UNAME))","MINGW")
  OS = MINGW
  PIC = 0
endif
ifeq ("$(OS)","NONE")
  $(error OS type "$(UNAME)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
endif

# detect system architecture
HOST_CPU ?= $(shell uname -m)
CPU := NONE
ifneq ("$(filter x86_64 amd64,$(HOST_CPU))","")
  CPU := X86
  ifeq ("$(BITS)", "32")
    ARCH_DETECTED := 64BITS_32
    PIC ?= 0
  else
    ARCH_DETECTED := 64BITS
    PIC ?= 1
  endif
endif
ifneq ("$(filter pentium i%86,$(HOST_CPU))","")
  CPU := X86
  ARCH_DETECTED := 32BITS
  PIC ?= 0
endif
ifneq ("$(filter ppc macppc socppc powerpc,$(HOST_CPU))","")
  CPU := PPC
  ARCH_DETECTED := 32BITS
  BIG_ENDIAN := 1
  PIC ?= 1
  NO_ASM := 1
  $(warning Architecture "$(HOST_CPU)" not officially supported.')
endif
ifneq ("$(filter ppc64 powerpc64,$(HOST_CPU))","")
  CPU := PPC
  ARCH_DETECTED := 64BITS
  BIG_ENDIAN := 1
  PIC ?= 1
  NO_ASM := 1
  $(warning Architecture "$(HOST_CPU)" not officially supported.')
endif
ifneq ("$(filter arm%,$(HOST_CPU))","")
  ifeq ("$(filter arm%b,$(HOST_CPU))","")
    CPU := ARM
    ARCH_DETECTED := 32BITS
    PIC ?= 1
    NEW_DYNAREC := 1
    CFLAGS += -mfpu=vfp -mfloat-abi=softfp
    $(warning Architecture "$(HOST_CPU)" not officially supported.')
  endif
endif
ifeq ("$(CPU)","NONE")
  $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
endif

# base CFLAGS, LDLIBS, and LDFLAGS
OPTFLAGS ?= -O3 -flto
WARNFLAGS ?= -Wall
CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src -DM64P_PARALLEL
CXXFLAGS += -fvisibility-inlines-hidden
LDLIBS +=  -lm

# Since we are building a shared library, we must compile with -fPIC on some architectures
# On 32-bit x86 systems we do not want to use -fPIC because we don't have to and it has a big performance penalty on this arch
ifeq ($(PIC), 1)
  CFLAGS += -fPIC
else
  CFLAGS += -fno-PIC
endif

ifeq ($(BIG_ENDIAN), 1)
  CFLAGS += -DM64P_BIG_ENDIAN
endif

# tweak flags for 32-bit build on 64-bit system
ifeq ($(ARCH_DETECTED), 64BITS_32)
  ifeq ($(OS), FREEBSD)
    $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
  endif
  CFLAGS += -m32
  LDFLAGS += -Wl,-m,elf_i386
endif

# set special flags per-system
ifeq ($(OS), FREEBSD)
  TARGET = libmupen64plus$(POSTFIX).so.2.0.0
  SONAME = libmupen64plus$(POSTFIX).so.2
  LDFLAGS += -Wl,-Bsymbolic -shared -Wl,-export-dynamic -Wl,-soname,$(SONAME)
  LDLIBS += -L${LOCALBASE}/lib -lc
endif
ifeq ($(OS), LINUX)
  TARGET = libmupen64plus$(POSTFIX).so.2.0.0
  SONAME = libmupen64plus$(POSTFIX).so.2
  LDFLAGS += -Wl,-Bsymbolic -shared -Wl,-export-dynamic -Wl,-soname,$(SONAME)
  LDLIBS += -ldl
  # only export api symbols
  LDFLAGS += -Wl,-version-script,$(SRCDIR)/api/api_export.ver
endif
ifeq ($(OS), OSX)
  # Select the proper SDK
  # Also, SDKs are stored in a different location since XCode 4.3
  OSX_SDK ?= $(shell sw_vers -productVersion | cut -f1 -f2 -d .)
  OSX_XCODEMAJ = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f1 -d .)
  OSX_XCODEMIN = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f2 -d .)
  OSX_XCODEGE43 = $(shell echo "`expr $(OSX_XCODEMAJ) \>= 4``expr $(OSX_XCODEMIN) \>= 3`")
  ifeq ($(OSX_XCODEGE43), 11)
    OSX_SYSROOT := /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs
  else
    OSX_SYSROOT := /Developer/SDKs
  endif

  TARGET = libmupen64plus$(POSTFIX).dylib
  LDFLAGS += -bundle -read_only_relocs suppress
  LDLIBS += -ldl
  ifeq ($(CPU), X86)
    ifeq ($(ARCH_DETECTED), 64BITS)
      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
    else
      CFLAGS += -pipe -mmmx -msse -arch i686 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
      ifneq ($(PROFILE), 1)
        CFLAGS += -fomit-frame-pointer
      endif
    endif
  endif
endif
ifeq ($(OS), MINGW)
  TARGET = mupen64plus$(POSTFIX).dll
  LDFLAGS += -Wl,-Bsymbolic -shared -Wl,-export-all-symbols
  # only export api symbols
  LDFLAGS += -Wl,-version-script,$(SRCDIR)/api/api_export.ver
  LDLIBS += -lpthread
endif

ifeq ($(CPU_ENDIANNESS), BIG)
  CFLAGS += -DM64P_BIG_ENDIAN
endif

# disable verbose output
ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
	Q_CC  = @echo '    CC  '$@;
	Q_CXX = @echo '    CXX '$@;
	Q_LD  = @echo '    LD  '$@;
endif
endif

# test for essential build dependencies
ifeq ($(origin PKG_CONFIG), undefined)
  PKG_CONFIG = $(CROSS_COMPILE)pkg-config
  ifeq ($(shell which $(PKG_CONFIG) 2>/dev/null),)
    $(error $(PKG_CONFIG) not found)
  endif
endif

ifeq ($(OS), OSX) # use system zlib on OSX
  ZLIB_LDLIBS += -lz
endif

ifeq ($(origin ZLIB_CFLAGS) $(origin ZLIB_LDLIBS), undefined undefined)
  ifeq ($(shell $(PKG_CONFIG) --modversion zlib 2>/dev/null),)
    $(error No zlib development libraries found!)
  endif
  ZLIB_CFLAGS += $(shell $(PKG_CONFIG) --cflags zlib)
  ZLIB_LDLIBS +=  $(shell $(PKG_CONFIG) --libs zlib)
endif
CFLAGS += $(ZLIB_CFLAGS)
LDLIBS += $(ZLIB_LDLIBS)

ifeq ($(origin LIBPNG_CFLAGS) $(origin LIBPNG_LDLIBS), undefined undefined)
  ifeq ($(shell $(PKG_CONFIG) --modversion libpng 2>/dev/null),)
    $(error No libpng development libraries found!)
  endif
  LIBPNG_CFLAGS += $(shell $(PKG_CONFIG) --cflags libpng)
  LIBPNG_LDLIBS +=  $(shell $(PKG_CONFIG) --libs libpng)
endif
CFLAGS += $(LIBPNG_CFLAGS)
LDLIBS += $(LIBPNG_LDLIBS)

# test for presence of SDL
ifeq ($(origin SDL_CFLAGS) $(origin SDL_LDLIBS), undefined undefined)
  SDL_CONFIG = $(CROSS_COMPILE)sdl-config
  ifeq ($(shell which $(SDL_CONFIG) 2>/dev/null),)
    $(error No SDL development libraries found!)
  endif
  SDL_CFLAGS  += $(shell $(SDL_CONFIG) --cflags)
  SDL_LDLIBS += $(shell $(SDL_CONFIG) --libs)
endif
CFLAGS += $(SDL_CFLAGS)
LDLIBS += $(SDL_LDLIBS)

OSD ?= 1
ifeq ($(OSD), 1)
  CFLAGS += -DM64P_OSD

  ifeq ($(origin FREETYPE2_CFLAGS) $(origin FREETYPE2_LDLIBS), undefined undefined)
    ifeq ($(shell $(PKG_CONFIG) --modversion freetype2 2>/dev/null),)
      $(error No freetype2 development libraries found!)
    endif
    FREETYPE2_CFLAGS += $(shell $(PKG_CONFIG) --cflags freetype2)
    FREETYPE2_LDLIBS +=  $(shell $(PKG_CONFIG) --libs freetype2)
  endif
  CFLAGS += $(FREETYPE2_CFLAGS)
  LDLIBS += $(FREETYPE2_LDLIBS)

  # search for OpenGL libraries
  ifeq ($(OS), OSX)
    GL_LDLIBS = -framework OpenGL
    GLU_LDLIBS = -framework OpenGL
  endif
  ifeq ($(OS), MINGW)
    GL_LDLIBS = -lopengl32
    GLU_LDLIBS = -lglu32
  endif

  ifeq ($(origin GL_CFLAGS) $(origin GL_LDLIBS), undefined undefined)
    ifeq ($(shell $(PKG_CONFIG) --modversion gl 2>/dev/null),)
      $(error No OpenGL development libraries found!)
    endif
    GL_CFLAGS += $(shell $(PKG_CONFIG) --cflags gl)
    GL_LDLIBS +=  $(shell $(PKG_CONFIG) --libs gl)
  endif
  CFLAGS += $(GL_CFLAGS)
  LDLIBS += $(GL_LDLIBS)

  ifeq ($(origin GLU_CFLAGS) $(origin GLU_LDLIBS), undefined undefined)
    ifeq ($(shell $(PKG_CONFIG) --modversion glu 2>/dev/null),)
      $(error No OpenGL utility development libraries found!)
    endif
    GLU_CFLAGS += $(shell $(PKG_CONFIG) --cflags glu)
    GLU_LDLIBS +=  $(shell $(PKG_CONFIG) --libs glu)
  endif
  CFLAGS += $(GLU_CFLAGS)
  LDLIBS += $(GLU_LDLIBS)
endif

# set base program pointers and flags
CC        = $(CROSS_COMPILE)gcc
CXX       = $(CROSS_COMPILE)g++
RM       ?= rm -f
INSTALL  ?= install
MKDIR ?= mkdir -p
COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
COMPILE.cc = $(Q_CXX)$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
LINK.o = $(Q_LD)$(CXX) $(CXXFLAGS) $(LDFLAGS) $(TARGET_ARCH)

ifeq ($(OS),OSX)
  LDCONFIG ?= true  # no 'ldconfig' under OSX
else
  ifeq ($(OS),LINUX)
    LDCONFIG ?= PATH="$$PATH:/sbin" ldconfig -n
  endif
  ifeq ($(OS),FREEBSD)
    LDCONFIG ?= PATH="$$PATH:/sbin" ldconfig -m
  endif
endif

# compiler/linker flags for various compile-time options.
# 1. macro for no assembly language
ifeq ($(NO_ASM), 1)
  CFLAGS += -DNO_ASM
endif
# 2. variables for profiling and adding debugging symbols
ifeq ($(PROFILE), 1)
  CFLAGS += -pg -g
  INSTALL_STRIP_FLAG ?= 
else
  ifeq ($(DEBUG), 1)
    CFLAGS += -g
    INSTALL_STRIP_FLAG ?= 
  else
    ifneq ($(OS),OSX)
      INSTALL_STRIP_FLAG ?= -s
	endif
  endif
endif
# 3. other options given to the makefile on the command line
ifeq ($(LIRC), 1)
  CFLAGS += -DWITH_LIRC
endif
ifeq ($(DEBUGGER), 1)
  CFLAGS += -DDBG
endif
ifeq ($(DBG_COMPARE), 1)
  CFLAGS += -DCOMPARE_CORE
endif
ifeq ($(DBG_CORE), 1)
  CFLAGS += -DCORE_DBG
endif
ifeq ($(DBG_COUNT), 1)
  CFLAGS += -DCOUNT_INSTR
endif
ifeq ($(DBG_TIMING), 1)
  CFLAGS += -DPROFILE
  LDFLAGS += -lrt
endif
ifeq ($(DBG_PROFILE), 1)
  CFLAGS += -DPROFILE_R4300
endif
# 4. compile-time directory paths for building into the library
ifneq ($(SHAREDIR),)
  CFLAGS += -DSHAREDIR="$(SHAREDIR)"
endif

# set installation options
ifeq ($(PREFIX),)
  PREFIX := /usr/local
endif
ifeq ($(SHAREDIR),)
  SHAREDIR := $(PREFIX)/share/mupen64plus
endif
ifeq ($(LIBDIR),)
  LIBDIR := $(PREFIX)/lib
endif
ifeq ($(INCDIR),)
  INCDIR := $(PREFIX)/include/mupen64plus
endif

SRCDIR = ../../src
OBJDIR = _obj$(POSTFIX)

# list of required source files for compilation
SOURCE = \
	$(SRCDIR)/api/callbacks.c \
	$(SRCDIR)/api/common.c \
	$(SRCDIR)/api/config.c \
	$(SRCDIR)/api/debugger.c \
	$(SRCDIR)/api/frontend.c \
	$(SRCDIR)/api/vidext.c \
	$(SRCDIR)/main/main.c \
	$(SRCDIR)/main/util.c \
	$(SRCDIR)/main/cheat.c \
	$(SRCDIR)/main/eventloop.c \
	$(SRCDIR)/main/md5.c \
	$(SRCDIR)/main/rom.c \
	$(SRCDIR)/main/savestates.c \
	$(SRCDIR)/main/workqueue.c \
	$(SRCDIR)/memory/dma.c \
	$(SRCDIR)/memory/flashram.c \
	$(SRCDIR)/memory/memory.c \
	$(SRCDIR)/memory/n64_cic_nus_6105.c \

=== debian/changelog ===
mupen64plus-core (2.0-4) unstable; urgency=low

  * Fix version number of the unicode FTBFS bug in the changelog
  * Upgraded to policy 3.9.5, no changes required
  * debian/patches:
    - Add oot_subscreen_delay_fix.patch, Add Missing Subscreen Delay Fix for
      Ocarina of Time
    - Add counter_per_op.patch, Allow to overwrite the cycles per instruction
    - Add two_events_interrupt.patch, Don't insert a second interrupt event
      from same type
    - Add delay_si.patch, Allow to disable interrupt delay after DMA SI
      read/write
    - Add config_currentstateslot.patch, Use correct config parameter string
      (CurrentSaveSlot->CurrentStateSlot)
    - Add obsolete_variable.patch, Remove obsolete variable; caused crashes
      in PD/Goldeneye in Android Ed.

 -- Sven Eckelmann <sven@narfation.org>  Fri, 13 Dec 2013 16:30:01 +0100

mupen64plus-core (2.0-3) unstable; urgency=low

  * debian/patches:
    - Add sdl2_no_unicode.patch, Remove SDL unicode keycode compat code
      (Closes: #720815)

 -- Sven Eckelmann <sven@narfation.org>  Sun, 25 Aug 2013 16:27:13 +0200

mupen64plus-core (2.0-2) unstable; urgency=low

  * debian/patches:
    - Add n64_cic_nus_6105_reset.patch, Reset PIF_RAMb 46,47 after the
      n64_cic_nus_6105 challenge
    - Add sdl2_select_saveslot.patch, Fix saveslot selection for SDL2
      (Closes: #717801)

 -- Sven Eckelmann <sven@narfation.org>  Thu, 25 Jul 2013 13:25:47 +0200

mupen64plus-core (2.0-1) unstable; urgency=low

  * New Upstream Version
  * Upload to unstable
  * debian/patches:
    - Add multiple_main.patch, Fix multiple definitions of main in same
      namespace
    - Remove dejavu-font.patch, Don't use Dejavu fonts because upstream
      uses other font
    - Add bitstream-font.patch, Use font from ttf-bitstream-vera instead
      of installing own copy with libmupen64plus2
    - Remove upstream merged country_code_bits.patch,
      sdl2_joystick_events.patch, sdl2_keyrepeat.patch and
      sdl2_resize.patch
  * debian/control:
    - Build-Depend on debhelper 9.20130604 for support of parameters when
      detecting targets in dh_auto_*
    - Replace dependency to ttf-dejavu-core with ttf-bitstream-vera
  * debian/rules:
    - Work around new debhelper 9.20130624 dh_auto_{clean,test} behavior
      which is causing a FTBFS by adding an explicit
      override_dh_auto_{clean,test} rule
  * debian/watch:
    - Verify new upstream versions using GPG key 954F81B094AA5BB226F5

 -- Sven Eckelmann <sven@narfation.org>  Fri, 05 Jul 2013 22:52:30 +0200

mupen64plus-core (2.0~rc3+3+5d46baa3dd76-2) experimental; urgency=low

  * debian/rules:
    - Switch from SDL 1.2 to SDL 2.0
  * debian/control:
    - Depend on libsdl2-dev instead of libsdl1.2-dev
    - Add Breaks for pre-SDL2 plugins
  * debian/patches:
    - Add sdl2_resize.patch, Fix compiling against SDL2
    - Add country_code_bits.patch, Ignore upper 8 bit of countrycode when
      checking for PAL/NTSC system
    - Add sdl2_keyrepeat.patch, Ignore key repeats caused by the OS keyrepeat
    - Add sdl2_joystick_events.patch, Simply open joystick when needed in SDL2
    - Add sdl2_keysym.patch, Use SDL1.2 keysym in the config when using SDL2
  * Update debian/copyright

 -- Sven Eckelmann <sven@narfation.org>  Sun, 23 Jun 2013 13:24:06 +0200

mupen64plus-core (2.0~rc3+3+5d46baa3dd76-1) experimental; urgency=low

  * New Upstream Snapshot from 5d46baa3dd7660365183e16596b288f824903007
  * debian/control:
    - Provide mupen64plus-frontend-abi-2.1.1
    - Remove old mupen64plus-frontend-abi-2.0.1/2.0.2
    - Provide mupen64plus-gfx-abi-2.2
    - Provide mupen64plus-vidext-abi-3
    - Remove old mupen64plus-vidext-abi-2
  * Enable link-time optimization in debian/rules similar to upstream
  * Add VidExt_ResizeWindow@Base to libmupen64plus2 symbols
  * debian/patches:
    - Rebase dejavu-font.patch, disable_recompiler_disassembler.patch and
      printf_fixup.patch on top of 2.0~rc3+3+5d46baa3dd76

 -- Sven Eckelmann <sven@narfation.org>  Wed, 05 Jun 2013 13:24:51 +0200

mupen64plus-core (1.99.5+178+cbd1bb2a5d6a-1) experimental; urgency=low

  * New Upstream Snapshot from cbd1bb2a5d6a9a04595a76412f89703d220981ed
  * Disable extra debug code in release builds with -DNDEBUG in
    debian/rules
  * debian/patches:
    - Rebase dejavu-font.patch and disable_recompiler_disassembler.patch on top
      of 1.99.5+178+cbd1bb2a5d6a

 -- Sven Eckelmann <sven@narfation.org>  Fri, 08 Feb 2013 10:15:13 +0100

mupen64plus-core (1.99.5+148+f259cbe4c1cd-1) experimental; urgency=low

  * New Upstream Snapshot from f259cbe4c1cd69f76aac9f8726c88993e3a96b70
  * Remove obsolete DM-Upload-Allowed in debian/control
  * debian/patches:
    - Rebase dejavu-font.patch, disable_recompiler_disassembler.patch and
      printf_fixup.patch on top of 1.99.5+148+f259cbe4c1cd

 -- Sven Eckelmann <sven@narfation.org>  Sun, 02 Dec 2012 22:32:11 +0100

mupen64plus-core (1.99.5+129+c7764c244288-1) experimental; urgency=low

  * New Upstream Snapshot from c7764c2442889c9dc19648df11a89ca88fb2d8fa
  * debian/patches:
    - Remove upstream merged dynarec_amd64_nostackreg.patch

 -- Sven Eckelmann <sven@narfation.org>  Tue, 30 Oct 2012 18:22:22 +0100

mupen64plus-core (1.99.5+117+a5698f5f67c1-1) experimental; urgency=low

  * New Upstream Snapshot from a5698f5f67c134bdaac66c04c09c2540cc62d606
  * Upgraded to policy 3.9.4, no changes required
  * debian/patches:
    - Add dynarec_amd64_nostackreg.patch, Don't store mapped host registers on
      stack before dynarec call

 -- Sven Eckelmann <sven@narfation.org>  Sun, 07 Oct 2012 14:23:26 +0200

mupen64plus-core (1.99.5+115+5afdc1c5e077-1) experimental; urgency=low

  * New Upstream Snapshot from 5afdc1c5e07718865400ff038a5dc3660e86d7a4
  * debian/patches:
    - Remove upstream merged config_type_switch_invalid_free.patch

 -- Sven Eckelmann <sven@narfation.org>  Sun, 16 Sep 2012 20:00:51 +0200

mupen64plus-core (1.99.5+113+481cdd269905-1) experimental; urgency=low



=== debian/control ===
Source: mupen64plus-core
Section: games
Priority: optional
Maintainer: Tobias Loose <TobiasLoose@gmx.de>
Uploaders: Sven Eckelmann <sven@narfation.org>
Standards-Version: 3.9.5
Homepage: http://code.google.com/p/mupen64plus/
Vcs-Git: git://anonscm.debian.org/collab-maint/mupen64plus-core.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mupen64plus-core.git
Build-Depends:
 debhelper (>= 9.20130604),
 dpkg-dev (>= 1.16.1.1),
 libfreetype6-dev,
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libpng-dev,
 libsdl2-dev,
 pkg-config,
 zlib1g-dev | libz-dev,

Package: libmupen64plus2
Section: libs
Architecture: any-i386 any-amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 mupen64plus-data,
 ttf-bitstream-vera,
Provides:
 mupen64plus-audio-abi-2,
 mupen64plus-config-abi-2.2,
 mupen64plus-debug-abi-2,
 mupen64plus-frontend-abi-2.1.1,
 mupen64plus-gfx-abi-2.1,
 mupen64plus-gfx-abi-2.2,
 mupen64plus-input-abi-2,
 mupen64plus-rsp-abi-2,
 mupen64plus-vidext-abi-3,
Breaks:
 mupen64plus-audio-sdl (<< 2.0),
 mupen64plus-input-sdl (<< 2.0),
 mupen64plus-video-glide64 (<< 2.0.0),
 mupen64plus-video-glide64mk2 (<< 2.0),
 mupen64plus-video-rice (<< 2.0),
 mupen64plus-video-z64 (<< 2.0.0),
Description: plugin-based Nintendo 64 emulator, core library
 Flexible N64 Emulator for Linux that works with many ROMs that are publically
 available. It consists of separate components to provide an user interface,
 audio and graphics output, controller input, co-processor emulation and an
 emulator core.
 .
 It has the following features:
  * cheat system
  * exchangeable plugins for graphics, sound and input emulation
  * multiple save states
  * common configuration system for all components
 .
 This package contains the actual emulator which must be loaded by a frontend.

Package: libmupen64plus2-dbg
Section: debug
Priority: extra
Architecture: any-i386 any-amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 libmupen64plus2 (= ${binary:Version}),
Description: mupen64plus debug symbols package
 Flexible N64 Emulator for Linux that works with many ROMs that are publically
 available. It consists of separate components to provide an user interface,
 audio and graphics output, controller input, co-processor emulation and an
 emulator core.
 .
 This package contains the debug files.

Package: libmupen64plus-dev
Section: libdevel
Architecture: all
Depends:
 ${misc:Depends},
Description: mupen64plus development package
 Flexible N64 Emulator for Linux that works with many ROMs that are publically
 available. It consists of separate components to provide an user interface,
 audio and graphics output, controller input, co-processor emulation and an
 emulator core.
 .
 This package contains everything which is needed to build plugins or frontends
 against the mupen64plus API.

Package: mupen64plus-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks:
 mupen64plus (<< 1.99.1),
 libmupen64plus2 (<< 1.99.5-3),
Replaces:
 mupen64plus (<< 1.99.1),
 libmupen64plus2 (<< 1.99.5-3),
Description: plugin-based Nintendo 64 emulator, data files
 Flexible N64 Emulator for Linux that works with many ROMs that are publically
 available. It consists of separate components to provide an user interface,
 audio and graphics output, controller input, co-processor emulation and an
 emulator core.
 .
 It has the following features:
  * cheat system
  * exchangeable plugins for graphics, sound and input emulation
  * multiple save states
  * common configuration system for all components
 .
 This package contains the rom catalog and cheat database.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
export DEB_CFLAGS_MAINT_APPEND=-flto

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 DEBUGGER=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG" SHAREDIR="/usr/share/games/mupen64plus/" SDL_CONFIG=sdl2-config
DBG_PACKAGE=$(shell dpkg-parsechangelog|grep '^Source: '|sed 's/^Source:\s*//')-dbg

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix" --parallel --list-missing

get-orig-source:
	$(CURDIR)/debian/get-orig-source.sh

override_dh_auto_test:
	# otherwise dh_auto_test fails with debhelper 9.20130624

override_dh_auto_clean:
	dh_auto_clean -- $(MAKEOPTIONS)

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

override_dh_strip:
	dh_strip -a --dbg-package=libmupen64plus2-dbg

override_dh_installchangelogs:
	dh_installchangelogs RELEASE

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	get-orig-source override_dh_auto_clean override_dh_auto_test override_dh_auto_build override_dh_auto_install override_dh_strip override_dh_installchangelogs

=== debian/watch ===
version=3

opts="pgpsigurlmangle=s/$/.asc/" \
 http://bitbucket.org/richard42/mupen64plus-core/downloads/ \
	/richard42/mupen64plus-core/downloads/mupen64plus-core-src-(.*\d).tar.gz

## mupen64plus-core 2.5

=== projects/unix/Makefile ===
--- 
+++ 
@@ -95,9 +95,33 @@
     ARCH_DETECTED := 32BITS
     PIC ?= 1
     NEW_DYNAREC := 1
-    CFLAGS += -mfpu=vfp -mfloat-abi=softfp
+    CFLAGS += -marm
+    ifneq ("$(filter armv5%,$(HOST_CPU))","")
+    	CFLAGS += -DARMv5_ONLY
+    	$(warning Using ARMv5_ONLY)
+    endif
+    ifneq ("$(filter armv6%,$(HOST_CPU))","")
+    	CFLAGS += -DARMv5_ONLY
+    	$(warning Using ARMv5_ONLY)
+    endif
+    ifeq ($(NEON), 1)
+        CFLAGS += -mfpu=neon -mfloat-abi=hard
+    else
+      ifeq ($(VFP_HARD), 1)
+        CFLAGS += -mfpu=vfp -mfloat-abi=hard
+      else
+        CFLAGS += -mfpu=vfp -mfloat-abi=softfp
+      endif
+    endif
     $(warning Architecture "$(HOST_CPU)" not officially supported.')
   endif
+endif
+ifneq ("$(filter mips,$(HOST_CPU))","")
+  CPU := MIPS
+  ARCH_DETECTED := 32BITS
+  PIC ?= 1
+  NO_ASM := 1
+  $(warning Architecture "$(HOST_CPU)" not officially supported.')
 endif
 ifeq ("$(CPU)","NONE")
   $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
@@ -105,7 +129,7 @@
 
 # base CFLAGS, LDLIBS, and LDFLAGS
 OPTFLAGS ?= -O3 -flto
-WARNFLAGS ?= -Wall
+WARNFLAGS ?= -Wall -Wno-unused-function
 CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src -DM64P_PARALLEL
 CXXFLAGS += -fvisibility-inlines-hidden
 LDLIBS +=  -lm
@@ -137,6 +161,7 @@
   SONAME = libmupen64plus$(POSTFIX).so.2
   LDFLAGS += -Wl,-Bsymbolic -shared -Wl,-export-dynamic -Wl,-soname,$(SONAME)
   LDLIBS += -L${LOCALBASE}/lib -lc
+  ASFLAGS = -f elf -d ELF_TYPE
 endif
 ifeq ($(OS), LINUX)
   TARGET = libmupen64plus$(POSTFIX).so.2.0.0
@@ -145,28 +170,22 @@
   LDLIBS += -ldl
   # only export api symbols
   LDFLAGS += -Wl,-version-script,$(SRCDIR)/api/api_export.ver
+  ASFLAGS = -f elf -d ELF_TYPE
 endif
 ifeq ($(OS), OSX)
-  # Select the proper SDK
-  # Also, SDKs are stored in a different location since XCode 4.3
-  OSX_SDK ?= $(shell sw_vers -productVersion | cut -f1 -f2 -d .)
-  OSX_XCODEMAJ = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f1 -d .)
-  OSX_XCODEMIN = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f2 -d .)
-  OSX_XCODEGE43 = $(shell echo "`expr $(OSX_XCODEMAJ) \>= 4``expr $(OSX_XCODEMIN) \>= 3`")
-  ifeq ($(OSX_XCODEGE43), 11)
-    OSX_SYSROOT := /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs
-  else
-    OSX_SYSROOT := /Developer/SDKs
-  endif
+  #xcode-select has been around since XCode 3.0, i.e. OS X 10.5
+  OSX_SDK_ROOT = $(shell xcode-select -print-path)/Platforms/MacOSX.platform/Developer/SDKs
+  OSX_SDK_PATH = $(OSX_SDK_ROOT)/$(shell ls $(OSX_SDK_ROOT) | tail -1)
 
   TARGET = libmupen64plus$(POSTFIX).dylib
-  LDFLAGS += -bundle -read_only_relocs suppress
+  LDFLAGS += -framework CoreFoundation -bundle -read_only_relocs suppress
   LDLIBS += -ldl
+  ASFLAGS = -f macho
   ifeq ($(CPU), X86)
     ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
+      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=10.5 -isysroot $(OSX_SDK_PATH)
     else
-      CFLAGS += -pipe -mmmx -msse -arch i686 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
+      CFLAGS += -pipe -mmmx -msse -arch i686 -mmacosx-version-min=10.5 -isysroot $(OSX_SDK_PATH)
       ifneq ($(PROFILE), 1)
         CFLAGS += -fomit-frame-pointer
       endif
@@ -179,6 +198,7 @@
   # only export api symbols
   LDFLAGS += -Wl,-version-script,$(SRCDIR)/api/api_export.ver
   LDLIBS += -lpthread
+  ASFLAGS = -f win32
 endif
 
 ifeq ($(CPU_ENDIANNESS), BIG)
@@ -190,6 +210,7 @@
 ifndef V
 	Q_CC  = @echo '    CC  '$@;
 	Q_CXX = @echo '    CXX '$@;
+	Q_AS  = @echo '    AS  '$@;
 	Q_LD  = @echo '    LD  '$@;
 endif
 endif
@@ -228,15 +249,34 @@
 
 # test for presence of SDL
 ifeq ($(origin SDL_CFLAGS) $(origin SDL_LDLIBS), undefined undefined)
-  SDL_CONFIG = $(CROSS_COMPILE)sdl-config
+  SDL_CONFIG = $(CROSS_COMPILE)sdl2-config
   ifeq ($(shell which $(SDL_CONFIG) 2>/dev/null),)
-    $(error No SDL development libraries found!)
+    SDL_CONFIG = $(CROSS_COMPILE)sdl-config
+    ifeq ($(shell which $(SDL_CONFIG) 2>/dev/null),)
+      $(error No SDL development libraries found!)
+    else
+      $(warning Using SDL 1.2 libraries)
+    endif
   endif
   SDL_CFLAGS  += $(shell $(SDL_CONFIG) --cflags)
   SDL_LDLIBS += $(shell $(SDL_CONFIG) --libs)
 endif
 CFLAGS += $(SDL_CFLAGS)
 LDLIBS += $(SDL_LDLIBS)
+
+ifeq ($(VC), 1)
+  CFLAGS += -DUSE_GLES -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads -I/opt/vc/include/vmcs_host/linux
+  LDLIBS += -L/opt/vc/lib -lGLESv2 -lEGL -lbcm_host -lvcos -lvchiq_arm
+  # OSD uses non-ES code and breaks attribs of video plugins
+  OSD=0
+endif
+
+ifeq ($(USE_GLES), 1)
+  CFLAGS += -DUSE_GLES
+  LDLIBS += -lGLESv2
+  # OSD uses non-ES code and breaks attribs of video plugins
+  OSD=0
+endif
 
 OSD ?= 1
 ifeq ($(OSD), 1)
@@ -286,11 +326,13 @@
 # set base program pointers and flags
 CC        = $(CROSS_COMPILE)gcc
 CXX       = $(CROSS_COMPILE)g++
+AS        = nasm
 RM       ?= rm -f
 INSTALL  ?= install
 MKDIR ?= mkdir -p
 COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
 COMPILE.cc = $(Q_CXX)$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
+COMPILE.as = $(Q_AS)$(AS) $(ASFLAGS)
 LINK.o = $(Q_LD)$(CXX) $(CXXFLAGS) $(LDFLAGS) $(TARGET_ARCH)
 
 ifeq ($(OS),OSX)
@@ -346,45 +388,3 @@
 ifeq ($(DBG_PROFILE), 1)
   CFLAGS += -DPROFILE_R4300
 endif
-# 4. compile-time directory paths for building into the library
-ifneq ($(SHAREDIR),)
-  CFLAGS += -DSHAREDIR="$(SHAREDIR)"
-endif
-
-# set installation options
-ifeq ($(PREFIX),)
-  PREFIX := /usr/local
-endif
-ifeq ($(SHAREDIR),)
-  SHAREDIR := $(PREFIX)/share/mupen64plus
-endif
-ifeq ($(LIBDIR),)
-  LIBDIR := $(PREFIX)/lib
-endif
-ifeq ($(INCDIR),)
-  INCDIR := $(PREFIX)/include/mupen64plus
-endif
-
-SRCDIR = ../../src
-OBJDIR = _obj$(POSTFIX)
-
-# list of required source files for compilation
-SOURCE = \
-	$(SRCDIR)/api/callbacks.c \
-	$(SRCDIR)/api/common.c \
-	$(SRCDIR)/api/config.c \
-	$(SRCDIR)/api/debugger.c \
-	$(SRCDIR)/api/frontend.c \
-	$(SRCDIR)/api/vidext.c \
-	$(SRCDIR)/main/main.c \
-	$(SRCDIR)/main/util.c \
-	$(SRCDIR)/main/cheat.c \
-	$(SRCDIR)/main/eventloop.c \
-	$(SRCDIR)/main/md5.c \
-	$(SRCDIR)/main/rom.c \
-	$(SRCDIR)/main/savestates.c \
-	$(SRCDIR)/main/workqueue.c \
-	$(SRCDIR)/memory/dma.c \
-	$(SRCDIR)/memory/flashram.c \
-	$(SRCDIR)/memory/memory.c \
-	$(SRCDIR)/memory/n64_cic_nus_6105.c \

=== debian/changelog ===
mupen64plus-core (2.5-8) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.6.0, no changes required
    - Switch to correct DEP-14 unstable branch name
    - Switch to fonts-dejavu-core for OSD (Closes: #998271)

 -- Sven Eckelmann <sven@narfation.org>  Mon, 01 Nov 2021 21:22:53 +0100

mupen64plus-core (2.5-7) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.5.0, no changes required
    - Allow build without (fake)root
    - Switch default Vcs-Git branch to debian/sid
    - Switch to debhelper compat 13
  * debian/copyright
    - Update copyright years to 2020
    - Use spaces to start continuation lines
  * Drop duplicated fields from upstream/metadata
  * Update debian/watch for format 4
  * debian/patches:
    - Add Fix-multiple-definition-errors.patch,
      Fix FTBFS with GCC 10 (Closes: #966344)

 -- Sven Eckelmann <sven@narfation.org>  Mon, 27 Jul 2020 15:33:11 +0200

mupen64plus-core (2.5-6) unstable; urgency=medium

  * debian/control:
    - Add Multi-Arch tags to packages without maintainer scripts and equal
      common files
    - Automatically select correct Vcs-Git branch
    - Upgraded to policy 4.4.0, no changes required
    - Switch to debhelper 12
  * debian/rules
    - Allow one to override pkg-config for crossbuilds
  * debian/copyright
    - Update copyright years to 2019

 -- Sven Eckelmann <sven@narfation.org>  Tue, 27 Aug 2019 23:20:30 +0200

mupen64plus-core (2.5-5) unstable; urgency=medium

  * debian/control
    - Change Vcs-Git to https://
    - update to debhelper 10
    - Move VCS-* to salsa.debian.org
  * Change debian URLs to https://
  * Sort debian control files with `wrap-and-sort -abst`
  * Upgraded to policy 4.2.1
    - remove get-orig-source rule from debian/rules
  * debian/copyright:
    - Update copyright years
  * debian/rules
    - Remove ddeb migration conflict against pre-stretch package
    - Drop (now default) parameter --parallel for dch
  * Add debian/upstream/metadata

 -- Sven Eckelmann <sven@narfation.org>  Thu, 18 Oct 2018 21:50:06 +0200

mupen64plus-core (2.5-4) unstable; urgency=medium

  * debian/rules:
    - Build armhf for reproducible CI with NEON and GLES

 -- Sven Eckelmann <sven@narfation.org>  Thu, 14 Jan 2016 22:36:53 +0100

mupen64plus-core (2.5-3) unstable; urgency=medium

  * debian/control, debian/rules:
     - Drop mupen64plus-core-dbg in favor of -dbgsym package
  * debian/patches:
    - Add Fix-spelling-errors.patch, Fix spelling errors
  * Update copyright years in debian/copyright

 -- Sven Eckelmann <sven@narfation.org>  Fri, 01 Jan 2016 12:27:13 +0100

mupen64plus-core (2.5-2) unstable; urgency=medium

  * debian/libmupen64plus2.symbols
    - move ConfigSetParameterHelp to the first official release version 2.5
  * debian/control:
    - Change Vcs-Browser to new alioth CGit URL
    - Move Vcs URLs from collab-maint to pkg-games
    - Update upstream URLs
    - Set Maintainer to Debian Games Team
  * debian/patches:
    - Move patches to alternative DEP-3 format and manage them with gbp pq
    - Add Use-pkg-config-to-find-GLESv2-library.patch, Use pkg-config to
      find GLESv2 library
    - Add Remove-unused-GLESv2-library.patch, Remove unused GLESv2 library
    - Add Avoid-.text-relocations-in-PIC-shared-library.patch, Avoid .text
      relocations in PIC shared library
    - Add bugfix-gameshark-cheat-codes-which-modified-executab.patch,
      fix gameshark cheat code which modify already recompiled code
    - Add fix-joystick-mapped-Core-events-under-SDL2.patch, Fix
      joystick-mapped Core events under SDL2

 -- Sven Eckelmann <sven@narfation.org>  Thu, 26 Nov 2015 07:51:05 +0100

mupen64plus-core (2.5-1) unstable; urgency=medium

  * New Upstream Verion
  * Upload to unstable
  * Upgraded to policy 3.9.6, no changes required
  * debian/copyright:
    - Update years
    - Fix errors in paths to specific files
    - Add new copyright information
  * debian/patches:
    - Remove upstream merged two_events_interrupt.patch

 -- Sven Eckelmann <sven@narfation.org>  Fri, 01 May 2015 15:12:14 +0200

mupen64plus-core (2.0+144+ga6ab125-1) experimental; urgency=medium

  * New Upstream Snapshot from a6ab125a6a25263e6e1a66f834c3bfb9ebaf2275
  * debian/patches:
    - Remove upstream merged patches cheat_multiconditions.patch,
      cheatengine_workarounds.patch, complete_resolve_romdb.patch,
      config_currentstateslot.patch, counter_per_op.patch,
      countperop_hydrothunter.patch, countperop_romdb.patch,
      countperop_rominfo.patch, delay_si.patch, duplicates_cheatdb.patch,
      flashram_read_handing.patch, format_eeprom.patch,
      interpreter_cmd_link_unconditionally.patch, invalid_reference_romdb.patch,
      mario64_levitate.patch, multiple_main.patch, n64_cic_nus_6105_reset.patch,
      nfl_duplicates_cheatdb.patch, nondefault_resolve_romdb.patch,
      obsolete_variable.patch, oot_subscreen_delay_fix.patch,
      pilotwings_workarounds_romdb.patch, pokemon_snap_workarounds_romdb.patch,
      revert_wii64_eeprom.patch, sdl2_destroywindow.patch, sdl2_keysym.patch,
      sdl2_no_surface.patch, sdl2_no_unicode.patch, sdl2_select_saveslot.patch,
      self_reference_romdb.patch, turok2_duplicates_cheatdb.patch,
      whitelist_cheatdb.patch, workarounds_romdb.patch,
      zelda_workarounds_romdb.patch
  * Provide new mupen64plus-config-abi-2.3 virtual package in debian/control
  * Add new symbol ConfigSetParameterHelp to libmupen64plus2

 -- Sven Eckelmann <sven@narfation.org>  Fri, 05 Sep 2014 10:32:04 +0200

mupen64plus-core (2.0-7) unstable; urgency=medium

  * debian/rules:
    - Use Largefile Support enabled C API

 -- Sven Eckelmann <sven@narfation.org>  Sat, 30 Aug 2014 16:08:27 +0200

mupen64plus-core (2.0-6) unstable; urgency=medium

  * debian/control:
    - Add Build-Depends for libminizip-dev

 -- Sven Eckelmann <sven@narfation.org>  Wed, 25 Jun 2014 15:13:09 +0200

mupen64plus-core (2.0-5) unstable; urgency=medium

  * debian/patches:


=== debian/control ===
Source: mupen64plus-core
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Sven Eckelmann <sven@narfation.org>,
 Tobias Loose <TobiasLoose@gmx.de>,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: http://mupen64plus.org/
Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-core.git -b debian/unstable
Vcs-Browser: https://salsa.debian.org/games-team/mupen64plus-core
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.16.1.1),
 libfreetype6-dev,
 libgl1-mesa-dev [any-i386 any-amd64] | libgl-dev [any-i386 any-amd64],
 libglu1-mesa-dev [any-i386 any-amd64] | libglu-dev [any-i386 any-amd64],
 libminizip-dev,
 libpng-dev,
 libsdl2-dev,
 pkg-config,
 zlib1g-dev | libz-dev,

Package: libmupen64plus-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: mupen64plus development package
 Flexible N64 Emulator for Linux that works with many ROMs that are publically
 available. It consists of separate components to provide an user interface,
 audio and graphics output, controller input, co-processor emulation and an
 emulator core.
 .
 This package contains everything which is needed to build plugins or frontends
 against the mupen64plus API.

Package: libmupen64plus2
Section: libs
Architecture: any-amd64 any-i386
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 mupen64plus-data,
 fonts-dejavu-core,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 mupen64plus-audio-abi-2,
 mupen64plus-config-abi-2.2,
 mupen64plus-config-abi-2.3,
 mupen64plus-debug-abi-2,
 mupen64plus-frontend-abi-2.1.1,
 mupen64plus-gfx-abi-2.1,
 mupen64plus-gfx-abi-2.2,
 mupen64plus-input-abi-2,
 mupen64plus-rsp-abi-2,
 mupen64plus-vidext-abi-3,
Breaks:
 mupen64plus-audio-sdl (<< 2.0),
 mupen64plus-input-sdl (<< 2.0),
 mupen64plus-video-glide64 (<< 2.0.0),
 mupen64plus-video-glide64mk2 (<< 2.0),
 mupen64plus-video-rice (<< 2.0),
 mupen64plus-video-z64 (<< 2.0.0),
Description: plugin-based Nintendo 64 emulator, core library
 Flexible N64 Emulator for Linux that works with many ROMs that are publically
 available. It consists of separate components to provide an user interface,
 audio and graphics output, controller input, co-processor emulation and an
 emulator core.
 .
 It has the following features:
  * cheat system
  * exchangeable plugins for graphics, sound and input emulation
  * multiple save states
  * common configuration system for all components
 .
 This package contains the actual emulator which must be loaded by a frontend.

Package: mupen64plus-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks:
 libmupen64plus2 (<< 1.99.5-3),
 mupen64plus (<< 1.99.1),
Replaces:
 libmupen64plus2 (<< 1.99.5-3),
 mupen64plus (<< 1.99.1),
Description: plugin-based Nintendo 64 emulator, data files
 Flexible N64 Emulator for Linux that works with many ROMs that are publically
 available. It consists of separate components to provide an user interface,
 audio and graphics output, controller input, co-processor emulation and an
 emulator core.
 .
 It has the following features:
  * cheat system
  * exchangeable plugins for graphics, sound and input emulation
  * multiple save states
  * common configuration system for all components
 .
 This package contains the rom catalog and cheat database.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildtools.mk

export PKG_CONFIG ?= pkg-config
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
export DEB_CFLAGS_MAINT_APPEND=-flto
export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 DEBUGGER=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG" SHAREDIR="/usr/share/games/mupen64plus/" SDL_CONFIG=sdl2-config

ifeq ($(DEB_HOST_ARCH),armhf)
MAKEOPTIONS += USE_GLES=1 NEON=1
endif

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix"

override_dh_auto_test:
	# otherwise dh_auto_test fails with debhelper 9.20130624

override_dh_auto_clean:
	dh_auto_clean -- $(MAKEOPTIONS)

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

override_dh_installchangelogs:
	dh_installchangelogs RELEASE

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	override_dh_auto_clean override_dh_auto_test override_dh_auto_build override_dh_auto_install override_dh_installchangelogs

=== debian/watch ===
version=4

opts="pgpsigurlmangle=s/$/.asc/" \
 https://github.com/mupen64plus/mupen64plus-core/releases \
	/mupen64plus/mupen64plus-core/releases/download/[^/]+/mupen64plus-core-src-(.*\d).tar.gz

## mupen64plus-core 2.5.9

=== debian/changelog ===
mupen64plus-core (2.5.9-1) experimental; urgency=medium

  * New Upstream Version
  * debian/control:
    - Add Multi-Arch tags to packages without maintainer scripts and equal
      common files
    - Add new build dependency nasm
    - Provide new ABI versions
      + mupen64plus-config-abi-2.3.1
      + mupen64plus-debug-abi-2.0.1
      + mupen64plus-frontend-abi-2.1.2
      + mupen64plus-input-abi-2.1
      + mupen64plus-vidext-abi-3.1
    - Upgraded to policy 4.3.0, no changes required
    - Add OpenCV video input backend
    - Switch to debhelper 12
  * debian/libmupen64plus2.symbols:
    - Add new symbols to libmupen64plus2
      + ConfigExternalClose
      + ConfigExternalGetParameter
      + ConfigExternalOpen
      + DebugBreakpointTriggeredBy
      + DebugVirtualToPhysical
      + VidExt_GL_GetDefaultFramebuffer
  * debian/patches:
    - Add bump-API-version-to-2.1.0-and-modify-input-plugin-attach-.patch,
      Update input API version to 2.1
    - Add fix-issue-627-improve-security-by-making-stack-segment-no.patch,
      improve security by making stack segment not executable
  * debian/rules
    - Allow one to override pkg-config for crossbuilds
  * debian/copyright
    - Update copyright years to 2019
    - Add copyright for new files

 -- Sven Eckelmann <sven@narfation.org>  Sat, 02 Mar 2019 20:16:59 +0100

=== debian/control ===
--- 
+++ 
@@ -5,20 +5,21 @@
 Uploaders:
  Sven Eckelmann <sven@narfation.org>,
  Tobias Loose <TobiasLoose@gmx.de>,
-Standards-Version: 4.6.0
-Rules-Requires-Root: no
+Standards-Version: 4.3.0
 Homepage: http://mupen64plus.org/
-Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-core.git -b debian/unstable
+Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-core.git
 Vcs-Browser: https://salsa.debian.org/games-team/mupen64plus-core
 Build-Depends:
- debhelper-compat (= 13),
+ debhelper (>= 12),
  dpkg-dev (>= 1.16.1.1),
  libfreetype6-dev,
  libgl1-mesa-dev [any-i386 any-amd64] | libgl-dev [any-i386 any-amd64],
  libglu1-mesa-dev [any-i386 any-amd64] | libglu-dev [any-i386 any-amd64],
  libminizip-dev,
+ libopencv-dev,
  libpng-dev,
  libsdl2-dev,
+ nasm,
  pkg-config,
  zlib1g-dev | libz-dev,
 
@@ -45,20 +46,24 @@
  ${misc:Pre-Depends},
 Depends:
  mupen64plus-data,
- fonts-dejavu-core,
+ ttf-bitstream-vera,
  ${misc:Depends},
  ${shlibs:Depends},
 Provides:
  mupen64plus-audio-abi-2,
  mupen64plus-config-abi-2.2,
  mupen64plus-config-abi-2.3,
+ mupen64plus-config-abi-2.3.1,
  mupen64plus-debug-abi-2,
+ mupen64plus-debug-abi-2.0.1,
  mupen64plus-frontend-abi-2.1.1,
+ mupen64plus-frontend-abi-2.1.2,
  mupen64plus-gfx-abi-2.1,
  mupen64plus-gfx-abi-2.2,
- mupen64plus-input-abi-2,
+ mupen64plus-input-abi-2.1,
  mupen64plus-rsp-abi-2,
  mupen64plus-vidext-abi-3,
+ mupen64plus-vidext-abi-3.1,
 Breaks:
  mupen64plus-audio-sdl (<< 2.0),
  mupen64plus-input-sdl (<< 2.0),

=== debian/rules ===
--- 
+++ 
@@ -7,13 +7,14 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
 export DEB_CFLAGS_MAINT_APPEND=-flto
 export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 DEBUGGER=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG" SHAREDIR="/usr/share/games/mupen64plus/" SDL_CONFIG=sdl2-config
+MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 DEBUGGER=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG" SHAREDIR="/usr/share/games/mupen64plus/" SDL_CONFIG=sdl2-config OPENCV=1
 
 ifeq ($(DEB_HOST_ARCH),armhf)
 MAKEOPTIONS += USE_GLES=1 NEON=1
